<?php
/**
 * Copyright (C) 2019 Leipzig University Library
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * @author  Sebastian Kehr <kehr@ub.uni-leipzig.de>
 * @license http://opensource.org/licenses/gpl-2.0.php GNU GPLv2
 */

namespace fid\Listener;

use ProxyManager\Factory\LazyLoadingValueHolderFactory;
use Psr\Container\ContainerInterface;
use VuFind\Auth\Manager as AuthManager;
use Zend\Mvc\Controller\Plugin\Redirect;
use Zend\Mvc\Controller\PluginManager;

class ErrorListenerFactory
{
    public function __invoke(ContainerInterface $container)
    {
        /** @var AuthManager $manager */
        $manager = $container->get(AuthManager::class);
        $factory = new LazyLoadingValueHolderFactory();
        /** @var Redirect $redirect */
        $redirect = $factory->createProxy(Redirect::class,
            function (&$instance, $proxy, $method, $params, &$initializer)
            use ($container) {
                $initializer = null;
                $instance = $container->get(PluginManager::class)
                    ->get(Redirect::class);
            });

        return new ErrorListener($manager, $redirect);
    }
}