<?php
/**
 * Copyright (C) 2019 Leipzig University Library
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * @author  Sebastian Kehr <kehr@ub.uni-leipzig.de>
 * @license http://opensource.org/licenses/gpl-2.0.php GNU GPLv2
 */

namespace fid_adlr\InputFilter;

use fid\InputFilter\RootAwareBaseInputFilter;

class UserCreateFormInputFilter extends RootAwareBaseInputFilter
{
    public function getValues()
    {
        $values = parent::getValues();
        $permission = $this->getPermission($values);
        $permissions = [$permission => 'granted'];
        return compact('permissions') + $values;
    }

    protected function getPermission($values): string
    {
        switch ($values['job_title']) {
            case '6':
            case '7':
            case '9':
                return 'limited_access';
            case '8':
                return 'extended_access';
            default:
                return 'full_access';
        }
    }
}
